/*******************************************************************************
 * Copyright (c) 2015-2016, IncQuery Labs Ltd. and Ericsson AB
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Akos Horvath, Abel Hegedus, Zoltan Ujhelyi, Daniel Segesdi, Tamas Borbas, Robert Doczi, Peter Lunk, Istvan Papp - initial API and implementation
 *******************************************************************************/
package com.incquerylabs.emdw.cpp.codegeneration.templates

import com.ericsson.xtumlrt.oopl.cppmodel.CPPStructMember
import com.ericsson.xtumlrt.oopl.cppmodel.CPPStructType
import com.incquerylabs.emdw.cpp.common.TypeConverter
import com.ericsson.xtumlrt.oopl.cppmodel.CPPQualifiedNamedElement

class StructTemplates {
	extension val TypeConverter typeConverter
	
	new() {
		typeConverter = new TypeConverter
	}
	
	def cppStructTemplate(CPPStructType cppStructType) {
		val structMembers = cppStructType.members.filter(CPPStructMember)
		'''
		struct «cppStructType.cppName» {
			«FOR structMember : structMembers»
				«structMember.type.convertToType» «structMember.cppName»;
			«ENDFOR»
		};
		'''
	}
	
	def cppStructInContainer(CPPQualifiedNamedElement cppContainer) {
		'''
		«FOR cppStructType : cppContainer.subElements.filter(CPPStructType)»
			«cppStructType.cppStructTemplate»
		«ENDFOR»
		'''
	}
}