/**
 * Copyright (c) 2015-2016 IncQuery Labs Ltd. and Ericsson AB
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Akos Horvath, Abel Hegedus, Zoltan Ujhelyi, Tamas Borbas - initial API and implementation
 */
package com.incquerylabs.emdw.valuedescriptor;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see com.incquerylabs.emdw.valuedescriptor.ValuedescriptorPackage
 * @generated
 */
public interface ValuedescriptorFactory extends EFactory {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = "Copyright (c) 2015-2016 IncQuery Labs Ltd. and Ericsson AB\r\nAll rights reserved. This program and the accompanying materials\r\nare made available under the terms of the Eclipse Public License v1.0\r\nwhich accompanies this distribution, and is available at\r\nhttp://www.eclipse.org/legal/epl-v10.html\r\n\r\nContributors:\r\n    Akos Horvath, Abel Hegedus, Zoltan Ujhelyi, Tamas Borbas - initial API and implementation";

	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	ValuedescriptorFactory eINSTANCE = com.incquerylabs.emdw.valuedescriptor.impl.ValuedescriptorFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Literal Descriptor</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Literal Descriptor</em>'.
	 * @generated
	 */
	LiteralDescriptor createLiteralDescriptor();

	/**
	 * Returns a new object of class '<em>Operation Call Descriptor</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Operation Call Descriptor</em>'.
	 * @generated
	 */
	OperationCallDescriptor createOperationCallDescriptor();

	/**
	 * Returns a new object of class '<em>Single Variable Descriptor</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Single Variable Descriptor</em>'.
	 * @generated
	 */
	SingleVariableDescriptor createSingleVariableDescriptor();

	/**
	 * Returns a new object of class '<em>Collection Variable Descriptor</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Collection Variable Descriptor</em>'.
	 * @generated
	 */
	CollectionVariableDescriptor createCollectionVariableDescriptor();

	/**
	 * Returns a new object of class '<em>Property Read Descriptor</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Property Read Descriptor</em>'.
	 * @generated
	 */
	PropertyReadDescriptor createPropertyReadDescriptor();

	/**
	 * Returns a new object of class '<em>Property Write Descriptor</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Property Write Descriptor</em>'.
	 * @generated
	 */
	PropertyWriteDescriptor createPropertyWriteDescriptor();

	/**
	 * Returns a new object of class '<em>Parameter Descriptor</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Parameter Descriptor</em>'.
	 * @generated
	 */
	ParameterDescriptor createParameterDescriptor();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	ValuedescriptorPackage getValuedescriptorPackage();

} //ValuedescriptorFactory
